import numpy as np
import matplotlib.pyplot as plt
from math import *
from sklearn import tree
from sklearn.linear_model import LinearRegression
from sklearn.ensemble import RandomForestClassifier
from sklearn.cluster import KMeans
import pandas as pd

#Opening all the csv files in the python program and convert them into lists
data = pd.read_csv('FactPuissance.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_FactPuissance=data.resample('30S').pad()
data_FactPuissance['value'][0] = 0.78

FactPuissance = data_FactPuissance['value']

data = pd.read_csv('PuissanceReact.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_PuissanceReact=data.resample('30S').pad()

Preactive = data_PuissanceReact['value']

data = pd.read_csv('PuissanceApp.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_PuissanceApp=data.resample('30S').pad()

Papparente = data_PuissanceApp['value']

data = pd.read_csv('Courant.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_Courant=data.resample('30S').pad()

Courant = data_Courant['value']

data = pd.read_csv('Tension.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_Tension=data.resample('30S').pad()

Tension = data_Tension['value']

data = pd.read_csv('Four.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_Four=data.resample('30S').pad()

Four = data_Four['value']

data = pd.read_csv('Television.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_Television=data.resample('30S').pad()

TV = data_Television['value']

data = pd.read_csv('MachineALaver.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_MachineALaver=data.resample('30S').pad()

Lavelinge = data_MachineALaver['value']

data = pd.read_csv('LaveVaisselle.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_LaveVaisselle=data.resample('30S').pad()
print(data_LaveVaisselle)

Lavevaisselle = data_LaveVaisselle['value']

data = pd.read_csv('PlaquesInduction.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_PlaquesInduction=data.resample('30S').pad()

Plaques = data_PlaquesInduction['value']

data = pd.read_csv('RobotsMenagers.csv', sep=",")
data['time'] = pd.to_datetime(data['time'])
pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
data.set_index('time', inplace=True)
data_RobotsMenagers=data.resample('30S').pad()

Robots = data_RobotsMenagers['value']


L = 50000
data = np.zeros((L,9))

#Making the lists readable for sklearn librarie
FactPuissance[0] = FactPuissance[1]
Courant[0] = Courant[1]
Tension[0] = Tension[1]
TV[0] = TV[1]
Lavelinge[0] = Lavelinge[1]
Lavevaisselle[0] = Lavevaisselle[1]
Plaques[0] = Plaques[1]
Robots[0] = Robots[1]
Four[0] = Four[1]
Papparente[0] = Papparente[1]
Preactive[0] = Preactive[1]

#Creating the data array with all the interessant features
for k in range(L):
    #data[k,0] = Papparente[k]
    #data[k,1] = Preactive[k]
    #data[k,0] = Courant[k]
    #data[k,1] = Tension[k]
    data[k,0] = Four[k]
    data[k,1] = TV[k]
    data[k,2] = Lavelinge[k]
    data[k,3] = Lavevaisselle[k]
    data[k,4] = Plaques[k]
    data[k,5] = Robots[k]
    data[k,6] = FactPuissance[k]

#Creating the regression model
a = int(7*L/10)

X = data[:a,:6]
y = data[:a,6]

reg = LinearRegression().fit(X, y)

test = []
t = []

err = 0
compta = 0
comptb = 0

#testing the model with the remaining data
for i in range(a,L):
    arr = np.array([[data[i,0],data[i,1],data[i,2],data[i,3],data[i,4],data[i,5]]])
    test1 = reg.predict(arr)
    test.append(test1)
    t.append(i)

    err = err + abs(test1-data[i,6])

    if test1 == data[i,6]:
        comptb = comptb+1
    compta = compta+1

#Checking the validity of the model
print("erreur moyenne")
print(err/(L-a))
print("précision")
print(comptb/compta)

plt.figure()
plt.plot(t,test,label = "prédit")
plt.plot(t,data[a:,6],label = "réel")
plt.legend()
plt.show()
plt.close()

importance = reg.coef_
for i,v in enumerate(importance):
    print("Feature: %0d, Score: %.5f"%(i,v))
plt.bar([x for x in range(len(importance))], importance)
plt.show()